org.apache.commons.math3.linear

## Interface FieldMatrix<T extends FieldElement<T>>

- Type Parameters:
    `T` - the type of the field elements
  All Superinterfaces:
    AnyMatrix
  All Known Implementing Classes:
    AbstractFieldMatrix, Array2DRowFieldMatrix, BlockFieldMatrix, SparseFieldMatrix

      public interface FieldMatrix<T extends FieldElement<T>>
      extends AnyMatrix

  Interface defining field-valued matrix with basic algebraic operations.

  Matrix element indexing is 0-based -- e.g., `getEntry(0, 0)` returns the element in the first row, first column of the matrix.

  Version:
    $Id: FieldMatrix.java 1244107 2012-02-14 16:17:55Z erans $

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FieldMatrix<T>` | `add(FieldMatrix<T> m)` Compute the sum of this and m.
    `void` | `addToEntry(int row, int column, T increment)` Change an entry in the specified row and column.
    `FieldMatrix<T>` | `copy()` Make a (deep) copy of this.
    `void` | `copySubMatrix(int[] selectedRows, int[] selectedColumns, T[][] destination)` Copy a submatrix.
    `void` | `copySubMatrix(int startRow, int endRow, int startColumn, int endColumn, T[][] destination)` Copy a submatrix.
    `FieldMatrix<T>` | `createMatrix(int rowDimension, int columnDimension)` Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
    `T[]` | `getColumn(int column)` Get the entries in column number `col` as an array.
    `FieldMatrix<T>` | `getColumnMatrix(int column)` Get the entries in column number `column` as a column matrix.
    `FieldVector<T>` | `getColumnVector(int column)` Returns the entries in column number `column` as a vector.
    `T[][]` | `getData()` Returns matrix entries as a two-dimensional array.
    `T` | `getEntry(int row, int column)` Returns the entry in the specified row and column.
    `Field<T>` | `getField()` Get the type of field elements of the matrix.
    `T[]` | `getRow(int row)` Get the entries in row number `row` as an array.
    `FieldMatrix<T>` | `getRowMatrix(int row)` Get the entries in row number `row` as a row matrix.
    `FieldVector<T>` | `getRowVector(int row)` Get the entries in row number `row` as a vector.
    `FieldMatrix<T>` | `getSubMatrix(int[] selectedRows, int[] selectedColumns)` Get a submatrix.
    `FieldMatrix<T>` | `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Get a submatrix.
    `T` | `getTrace()` Returns the trace of the matrix (the sum of the elements on the main diagonal).
    `FieldMatrix<T>` | `multiply(FieldMatrix<T> m)` Postmultiply this matrix by `m`.
    `void` | `multiplyEntry(int row, int column, T factor)` Change an entry in the specified row and column.
    `FieldVector<T>` | `operate(FieldVector<T> v)` Returns the result of multiplying this by the vector `v`.
    `T[]` | `operate(T[] v)` Returns the result of multiplying this by the vector `v`.
    `FieldMatrix<T>` | `power(int p)` Returns the result multiplying this with itself `p` times.
    `FieldMatrix<T>` | `preMultiply(FieldMatrix<T> m)` Premultiply this matrix by `m`.
    `FieldVector<T>` | `preMultiply(FieldVector<T> v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `T[]` | `preMultiply(T[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
    `FieldMatrix<T>` | `scalarAdd(T d)` Increment each entry of this matrix.
    `FieldMatrix<T>` | `scalarMultiply(T d)` Multiply each entry by `d`.
    `void` | `setColumn(int column, T[] array)` Set the entries in column number `column` as a column matrix.
    `void` | `setColumnMatrix(int column, FieldMatrix<T> matrix)` Set the entries in column number `column` as a column matrix.
    `void` | `setColumnVector(int column, FieldVector<T> vector)` Set the entries in column number `column` as a vector.
    `void` | `setEntry(int row, int column, T value)` Set the entry in the specified row and column.
    `void` | `setRow(int row, T[] array)` Set the entries in row number `row` as a row matrix.
    `void` | `setRowMatrix(int row, FieldMatrix<T> matrix)` Set the entries in row number `row` as a row matrix.
    `void` | `setRowVector(int row, FieldVector<T> vector)` Set the entries in row number `row` as a vector.
    `void` | `setSubMatrix(T[][] subMatrix, int row, int column)` Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array.
    `FieldMatrix<T>` | `subtract(FieldMatrix<T> m)` Subtract `m` from this matrix.
    `FieldMatrix<T>` | `transpose()` Returns the transpose of this matrix.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in column order.
    `T` | `walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in column order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
    `T` | `walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)` Visit (and possibly change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)` Visit (but don't change) all matrix entries in row order.
    `T` | `walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

    - ### Methods inherited from interface org.apache.commons.math3.linear.AnyMatrix

      `getColumnDimension, getRowDimension, isSquare`

- - ### Method Detail

    - #### getField

          Field<T> getField()

      Get the type of field elements of the matrix.
      Returns:
        the type of field elements of the matrix.

    - #### createMatrix

          FieldMatrix<T> createMatrix(int rowDimension,
                                    int columnDimension)

      Create a new FieldMatrix of the same type as the instance with the supplied row and column dimensions.
      Parameters:
        `rowDimension` - the number of rows in the new matrix
        `columnDimension` - the number of columns in the new matrix
      Returns:
        a new matrix of the same type as the instance
      Throws:
        `NotStrictlyPositiveException` - if row or column dimension is not positive.
      Since:
        2.0

    - #### copy

          FieldMatrix<T> copy()

      Make a (deep) copy of this.
      Returns:
        a copy of this matrix.

    - #### add

          FieldMatrix<T> add(FieldMatrix<T> m)

      Compute the sum of this and m.
      Parameters:
        `m` - Matrix to be added.
      Returns:
        `this` + `m`.
      Throws:
        `MatrixDimensionMismatchException` - if `m` is not the same size as this matrix.

    - #### subtract

          FieldMatrix<T> subtract(FieldMatrix<T> m)

      Subtract `m` from this matrix.
      Parameters:
        `m` - Matrix to be subtracted.
      Returns:
        `this` - `m`.
      Throws:
        `MatrixDimensionMismatchException` - if `m` is not the same size as this matrix.

    - #### scalarAdd

          FieldMatrix<T> scalarAdd(T d)

      Increment each entry of this matrix.
      Parameters:
        `d` - Value to be added to each entry.
      Returns:
        `d` + `this`.

    - #### scalarMultiply

          FieldMatrix<T> scalarMultiply(T d)

      Multiply each entry by `d`.
      Parameters:
        `d` - Value to multiply all entries by.
      Returns:
        `d` * `this`.

    - #### multiply

          FieldMatrix<T> multiply(FieldMatrix<T> m)

      Postmultiply this matrix by `m`.
      Parameters:
        `m` - Matrix to postmultiply by.
      Returns:
        `this` * `m`.
      Throws:
        `IllegalArgumentException` - if columnDimension(this) != rowDimension(m)

    - #### preMultiply

          FieldMatrix<T> preMultiply(FieldMatrix<T> m)

      Premultiply this matrix by `m`.
      Parameters:
        `m` - Matrix to premultiply by.
      Returns:
        `m` * `this`.
      Throws:
        `DimensionMismatchException` - if the number of columns of `m` differ from the number of rows of this matrix.

    - #### power

          FieldMatrix<T> power(int p)

      Returns the result multiplying this with itself `p` times. Depending on the type of the field elements, T, instability for high powers might occur.
      Parameters:
        `p` - raise this to power p
      Returns:
        this^p
      Throws:
        `IllegalArgumentException` - if p < 0 NonSquareMatrixException if the matrix is not square

    - #### getData

          T[][] getData()

      Returns matrix entries as a two-dimensional array.
      Returns:
        a 2-dimensional array of entries.

    - #### getSubMatrix

          FieldMatrix<T> getSubMatrix(int startRow,
                                    int endRow,
                                    int startColumn,
                                    int endColumn)

      Get a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Parameters:
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the matrix containing the data of the specified rows and columns.
      Throws:
        `OutOfRangeException` - if the indices are not valid.

    - #### getSubMatrix

          FieldMatrix<T> getSubMatrix(int[] selectedRows,
                                    int[] selectedColumns)

      Get a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
      Returns:
        the matrix containing the data in the specified rows and columns.
      Throws:
        `OutOfRangeException` - if row or column selections are not valid.

    - #### copySubMatrix

          void copySubMatrix(int startRow,
                           int endRow,
                           int startColumn,
                           int endColumn,
                           T[][] destination)

      Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.
      Parameters:
        `startRow` - Initial row index.
        `endRow` - Final row index (inclusive).
        `startColumn` - Initial column index.
        `endColumn` - Final column index (inclusive).
        `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used).
      Throws:
        `OutOfRangeException` - if the indices are not valid.
        `IllegalArgumentException` - if the destination array is too small.

    - #### copySubMatrix

          void copySubMatrix(int[] selectedRows,
                           int[] selectedColumns,
                           T[][] destination)

      Copy a submatrix. Rows and columns are indicated counting from 0 to n - 1.
      Parameters:
        `selectedRows` - Array of row indices.
        `selectedColumns` - Array of column indices.
        `destination` - Arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
      Throws:
        `OutOfRangeException` - if the indices are not valid.
        `IllegalArgumentException` - if the destination array is too small

    - #### setSubMatrix

          void setSubMatrix(T[][] subMatrix,
                          int row,
                          int column)

      Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array. Indexes are 0-based.

      Example:
      Starting with

           1  2  3  4
           5  6  7  8
           9  0  1  2

      and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

           1  2  3  4
           5  3  4  8
           9  5  6  2

      Parameters:
        `subMatrix` - Array containing the submatrix replacement data.
        `row` - Row coordinate of the top-left element to be replaced.
        `column` - Column coordinate of the top-left element to be replaced.
      Throws:
        `MatrixDimensionMismatchException` - if `subMatrix` does not fit into this matrix from element in `(row, column)`.
        `ZeroException` - if a row or column of `subMatrix` is empty.
        `DimensionMismatchException` - if `subMatrix` is not rectangular (not all rows have the same length).
        `NullArgumentException` - if `subMatrix` is `null`.
      Since:
        2.0

    - #### getRowMatrix

          FieldMatrix<T> getRowMatrix(int row)

      Get the entries in row number `row` as a row matrix.
      Parameters:
        `row` - Row to be fetched.
      Returns:
        a row matrix.
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.

    - #### setRowMatrix

          void setRowMatrix(int row,
                          FieldMatrix<T> matrix)

      Set the entries in row number `row` as a row matrix.
      Parameters:
        `row` - Row to be set.
        `matrix` - Row matrix (must have one row and the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance row.

    - #### getColumnMatrix

          FieldMatrix<T> getColumnMatrix(int column)

      Get the entries in column number `column` as a column matrix.
      Parameters:
        `column` - Column to be fetched.
      Returns:
        a column matrix.
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.

    - #### setColumnMatrix

          void setColumnMatrix(int column,
                             FieldMatrix<T> matrix)

      Set the entries in column number `column` as a column matrix.
      Parameters:
        `column` - Column to be set.
        `matrix` - column matrix (must have one column and the same number of rows as the instance).
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance column.

    - #### getRowVector

          FieldVector<T> getRowVector(int row)

      Get the entries in row number `row` as a vector.
      Parameters:
        `row` - Row to be fetched
      Returns:
        a row vector.
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.

    - #### setRowVector

          void setRowVector(int row,
                          FieldVector<T> vector)

      Set the entries in row number `row` as a vector.
      Parameters:
        `row` - Row to be set.
        `vector` - row vector (must have the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the vector dimension does not match one instance row.

    - #### getColumnVector

          FieldVector<T> getColumnVector(int column)

      Returns the entries in column number `column` as a vector.
      Parameters:
        `column` - Column to be fetched.
      Returns:
        a column vector.
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.

    - #### setColumnVector

          void setColumnVector(int column,
                             FieldVector<T> vector)

      Set the entries in column number `column` as a vector.
      Parameters:
        `column` - Column to be set.
        `vector` - Column vector (must have the same number of rows as the instance).
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the vector dimension does not match one instance column.

    - #### getRow

          T[] getRow(int row)

      Get the entries in row number `row` as an array.
      Parameters:
        `row` - Row to be fetched.
      Returns:
        array of entries in the row.
      Throws:
        `OutOfRangeException` - if the specified row index is not valid.

    - #### setRow

          void setRow(int row,
                    T[] array)

      Set the entries in row number `row` as a row matrix.
      Parameters:
        `row` - Row to be set.
        `array` - Row matrix (must have the same number of columns as the instance).
      Throws:
        `OutOfRangeException` - if the specified row index is invalid.
        `MatrixDimensionMismatchException` - if the array size does not match one instance row.

    - #### getColumn

          T[] getColumn(int column)

      Get the entries in column number `col` as an array.
      Parameters:
        `column` - the column to be fetched
      Returns:
        array of entries in the column
      Throws:
        `OutOfRangeException` - if the specified column index is not valid.

    - #### setColumn

          void setColumn(int column,
                       T[] array)

      Set the entries in column number `column` as a column matrix.
      Parameters:
        `column` - the column to be set
        `array` - column array (must have the same number of rows as the instance)
      Throws:
        `OutOfRangeException` - if the specified column index is invalid.
        `MatrixDimensionMismatchException` - if the array size does not match one instance column.

    - #### getEntry

          T getEntry(int row,
                   int column)

      Returns the entry in the specified row and column.
      Parameters:
        `row` - row location of entry to be fetched
        `column` - column location of entry to be fetched
      Returns:
        matrix entry in row,column
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.

    - #### setEntry

          void setEntry(int row,
                      int column,
                      T value)

      Set the entry in the specified row and column.
      Parameters:
        `row` - row location of entry to be set
        `column` - column location of entry to be set
        `value` - matrix entry to be set in row,column
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.
      Since:
        2.0

    - #### addToEntry

          void addToEntry(int row,
                        int column,
                        T increment)

      Change an entry in the specified row and column.
      Parameters:
        `row` - Row location of entry to be set.
        `column` - Column location of entry to be set.
        `increment` - Value to add to the current matrix entry in `(row, column)`.
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.
      Since:
        2.0

    - #### multiplyEntry

          void multiplyEntry(int row,
                           int column,
                           T factor)

      Change an entry in the specified row and column.
      Parameters:
        `row` - Row location of entry to be set.
        `column` - Column location of entry to be set.
        `factor` - Multiplication factor for the current matrix entry in `(row,column)`
      Throws:
        `OutOfRangeException` - if the row or column index is not valid.
      Since:
        2.0

    - #### transpose

          FieldMatrix<T> transpose()

      Returns the transpose of this matrix.
      Returns:
        transpose matrix

    - #### getTrace

          T getTrace()

      Returns the trace of the matrix (the sum of the elements on the main diagonal).
      Returns:
        trace
      Throws:
        `NonSquareMatrixException` - if the matrix is not square.

    - #### operate

          T[] operate(T[] v)

      Returns the result of multiplying this by the vector `v`.
      Parameters:
        `v` - the vector to operate on
      Returns:
        this*v
      Throws:
        `IllegalArgumentException` - if columnDimension != v.size()

    - #### operate

          FieldVector<T> operate(FieldVector<T> v)

      Returns the result of multiplying this by the vector `v`.
      Parameters:
        `v` - the vector to operate on
      Returns:
        this*v
      Throws:
        `IllegalArgumentException` - if columnDimension != v.size()

    - #### preMultiply

          T[] preMultiply(T[] v)

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        v*this
      Throws:
        `IllegalArgumentException` - if rowDimension != v.size()

    - #### preMultiply

          FieldVector<T> preMultiply(FieldVector<T> v)

      Returns the (row) vector result of premultiplying this by the vector `v`.
      Parameters:
        `v` - the row vector to premultiply by
      Returns:
        v*this
      Throws:
        `IllegalArgumentException` - if rowDimension != v.size()

    - #### walkInRowOrder

          T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)

      Visit (and possibly change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInRowOrder

          T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor,
                         int startRow,
                         int endRow,
                         int startColumn,
                         int endColumn)

      Visit (but don't change) some matrix entries in row order.

      Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          T walkInColumnOrder(FieldMatrixChangingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)

      Visit (and possibly change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInColumnOrder

          T walkInColumnOrder(FieldMatrixPreservingVisitor<T> visitor,
                            int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)

      Visit (but don't change) some matrix entries in column order.

      Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)

      Visit (and possibly change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)

      Visit (but don't change) all matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Parameters:
        `visitor` - visitor used to process all matrix entries
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)

      Visit (and possibly change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

    - #### walkInOptimizedOrder

          T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor,
                               int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)

      Visit (but don't change) some matrix entries using the fastest possible order.

      The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

      Parameters:
        `visitor` - visitor used to process all matrix entries
        `startRow` - Initial row index
        `endRow` - Final row index (inclusive)
        `startColumn` - Initial column index
        `endColumn` - Final column index (inclusive)
      Returns:
        the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
      Throws:
        `OutOfRangeException` - if the indices are not valid.
      See Also:
        `walkInRowOrder(FieldMatrixChangingVisitor)`, `walkInRowOrder(FieldMatrixPreservingVisitor)`, `walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixChangingVisitor)`, `walkInColumnOrder(FieldMatrixPreservingVisitor)`, `walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor)`, `walkInOptimizedOrder(FieldMatrixPreservingVisitor)`, `walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.